#include "stdafx.h"
#include "Factorize.h"
#include <algorithm>

NOINLINE void Factorize(number a, number& sumA, std::vector<std::pair<number, number>>& aFactorization)
{
	sumA = 1;
	unsigned long bitIndex;
	_BitScanForward64(&bitIndex, a);
	if (bitIndex > 0)
	{
		a >>= bitIndex;
		sumA = (number(1) << (bitIndex + 1)) - 1;
		aFactorization.push_back(std::make_pair(2, bitIndex));
		if ((a <= SearchLimit::PrimesUpToSqrtLimitValue) && IsPrime(a))
		{
			aFactorization.push_back(std::make_pair(a, 1));
			sumA *= a + 1;
			return;
		}
	}
	FactorizeInternal<1>(a, sumA, aFactorization);
	if (a > 1)
	{
		sumA *= (a + 1);
		if (aFactorization.empty() || (aFactorization.back().first != a))
			aFactorization.push_back(std::pair<number, number>(a, 1));
		else
			++aFactorization.back().second;
	}
}

NOINLINE void NormalizeFactorization(std::vector<std::pair<number, number>>& factorization)
{
	std::sort(factorization.begin(), factorization.end());
	auto j = factorization.begin();
	for (auto i = j + 1; i < factorization.end(); ++i)
	{
		if (i->first == j->first)
		{
			j->second += i->second;
		}
		else
		{
			++j;
			*j = *i;
		}
	}
	factorization.resize(size_t(j + 1 - factorization.begin()));
}

void PrintFactorization(std::ostream& s, std::vector<std::pair<number, number>>& factorization)
{
	bool first = true;
	for (const std::pair<number, number>& p : factorization)
	{
		if (!first)
			s << '*';
		first = false;
		s << p.first;
		if (p.second > 1)
			s << '^' << p.second;
	}
}
